import transformers
from transformers import AutoTokenizer
import pandas as pd
from workarena_src.prompt_v2 import wa_format_action_prompt_for_BC


if __name__ == '__main__':
    df = pd.read_csv('workarena_data/seen_seed_demo_iter_0.csv')
    tok = AutoTokenizer.from_pretrained("meta-llama/Meta-Llama-3.1-8B-Instruct")
    texts = []
    for i in range(len(df)):
        goal = df.goal.iloc[i]
        obs = df.observation.iloc[i]
        history = df.action_history.iloc[i]
        action = df.action.iloc[i]

        mp, sp = wa_format_action_prompt_for_BC(goal, history, obs)
        chat = [
            {'role':'system', 'content': sp},
            {'role':'user', 'content': mp},
            {'role':'assistant', 'content': f"<action>\n{action}\n</action>[END]"}
        ]
        text = tok.apply_chat_template(chat, tokenize=False)
        texts.append(text)
    df = pd.DataFrame({'text': texts})
    df.to_csv('workarena_data/bc_data.csv')